#pragma once

#include <RobotAPI/interface/armem/commit.h>
#include <RobotAPI/interface/armem/memory.h>

#include "ice_conversions_templates.h"

#include "Commit.h"
#include "base/detail/MemoryItem.h"


namespace IceUtil
{
    // Define in original namespace to allow ADL.
    inline void toIce(long& ice, const Time& time)
    {
        ice = time.toMicroSeconds();
    }
    inline void fromIce(const long& ice, Time& time)
    {
        time = Time::microSeconds(ice);
    }
}


namespace armarx::armem
{

    // void fromIce(long ice, Time& time);
    // void toIce(long& ice, const Time& time);

    void fromIce(const data::MemoryID& ice, MemoryID& id);
    void toIce(data::MemoryID& ice, const MemoryID& id);


    void fromIce(const data::Commit& ice, Commit& commit);
    void toIce(data::Commit& ice, const Commit& commit);

    void fromIce(const data::CommitResult& ice, CommitResult& result);
    void toIce(data::CommitResult& ice, const CommitResult& result);


    void fromIce(const data::EntityUpdate& ice, EntityUpdate& update);
    void toIce(data::EntityUpdate& ice, const EntityUpdate& update);

    void fromIce(const data::EntityUpdateResult& ice, EntityUpdateResult& result);
    void toIce(data::EntityUpdateResult& ice, const EntityUpdateResult& result);


    // Server-side conversion with specified arrival time.
    void fromIce(const data::Commit& ice, Commit& commit, Time timeArrived);
    void fromIce(const data::EntityUpdate& ice, EntityUpdate& update, Time timeArrived);


    namespace detail
    {
        void toIceItem(data::detail::MemoryItem& ice, const armem::base::detail::MemoryItem& item);
        void fromIceItem(const data::detail::MemoryItem& ice, armem::base::detail::MemoryItem& item);
    }

}

