#include "SceneSnapshot.h"

#include <SimoxUtility/json.h>

#include <RobotAPI/libraries/ArmarXObjects/ObjectID.h>

// #include <RobotAPI/libraries/armem/core/json_conversions.h>


namespace armarx::armem::obj
{

    ObjectID SceneSnapshot::Object::getClassID() const
    {
        return ObjectID(className);
    }

}


void armarx::armem::obj::to_json(nlohmann::json& j, const SceneSnapshot::Object& rhs)
{
    //     j["instanceID"] = rhs.instanceID;
    j["class"] = rhs.className;
    j["collection"] = rhs.collection;
    j["position"] = rhs.position;
    j["orientation"] = rhs.orientation;
}


void armarx::armem::obj::from_json(const nlohmann::json& j, SceneSnapshot::Object& rhs)
{
    //     j.at("instanceID").get_to(rhs.instanceID);
    j.at("class").get_to(rhs.className);
    j.at("collection").get_to(rhs.collection);
    j.at("position").get_to(rhs.position);
    j.at("orientation").get_to(rhs.orientation);
}



void armarx::armem::obj::to_json(nlohmann::json& j, const SceneSnapshot& rhs)
{
    j["objects"] = rhs.objects;
}


void armarx::armem::obj::from_json(const nlohmann::json& j, SceneSnapshot& rhs)
{
    j.at("objects").get_to(rhs.objects);
}


